{{ test_name }}:
  timeout: 24h
  needs:
    - pipeline: $PARENT_PIPELINE_ID
      job: build_rpm
      artifacts: true
{% for dep in depends_on %}
    - job: {{ dep }}
      artifacts: true
{% endfor %}
  artifacts:
    when: always
    paths:
      - {{ test_name }}_test_results.tar.gz
      - jobdata.txt
    expire_in: 6 months
    expose_as: 'Test Results'
  tags:
    - distrobaker
  image: images.paas.redhat.com/osci/ci-mediator-cli:68be74b6
{% if depends_on %}
  rules:
    - when: on_success
{% else %}
  rules:
    - when: always
{% endif %}

  variables:
    CI_MEDIATOR_API_URL: 'https://ci-mediator.osci.redhat.com/api/v1'
  script:
    - echo "Obtaining SSO access token"
    - SSO_CLIENT_SECRET=$(cat /opt/secrets/sso.secret)
    - ci-mediator get-sso-token --sso-client ci-mediator-client-osci --sso-secret $SSO_CLIENT_SECRET
    - source token
    - echo "Let's run {{ test_name }} on the following Brew task:" "https://brewweb.engineering.redhat.com/brew/taskinfo?taskID=$KOJI_TASK_ID"
    - RELEASE=$(echo "$KOJI_BUILD_TARGET" | sed 's/\(rhel-[0-9]\+\.[0-9]\+\(\.[0-9]\+\)\?\(-z\)\?\(-alpha\|-beta\)\?\).*/\1/g')
{% if strategy == "webhook" %}
    - ci-mediator workitem {{ test_name }} --from-artifact $KOJI_TASK_ID --additional-artifacts "$ADDITIONAL_ARTIFACTS" --release "$RELEASE" --output  # Saves 'work_item' file
    - WORKITEM_ID=$(jq -r '.id' work_item)
    - NVR=$(jq -r '.artifact.spec.nvr' work_item)
    - RHIVOS_API_TOKEN=$(cat /opt/secrets/rhivos.token)
    - |
      curl -XPOST \
        --form "token=${RHIVOS_API_TOKEN}" \
        --form "ref={{ webhook_ref }}" \
        --form "variables[WORKITEM_ID]=${WORKITEM_ID}" \
        --form "variables[NVR]=${NVR}" \
        {{ webhook_url }}
    # Assume RHIVOS pipeline has created a task
    - >
      ci-mediator workitem {{ test_name }} --watch $WORKITEM_ID || :
{% else %}
    - >
      ci-mediator workitem {{ test_name }} --from-artifact $KOJI_TASK_ID --additional-artifacts "$ADDITIONAL_ARTIFACTS" --release "$RELEASE" --wait --output || :  # Saves "work_item" file
    - WORKITEM_ID=$(jq -r '.id' work_item)
    - NVR=$(jq -r '.artifact.spec.nvr' work_item)
{% endif %}
    - ci-mediator get-tasks {{ test_name }} --workitem $WORKITEM_ID --output  # Saves "task" file
    - TASK_IDS=$(jq -r '.[].id' task)
    - |
      if echo $TASK_IDS | grep -q ' '; then
        ENV_FILE_GLOB={{ test_name }}.*.env
        HTML_FILE_GLOB={{ test_name }}.*.html
        MULTIPLE_TASKS=1
      else
        ENV_FILE_GLOB={{ test_name }}.env
        HTML_FILE_GLOB={{ test_name }}.html
        MULTIPLE_TASKS=0
      fi
      echo ENV_FILE_GLOB=$ENV_FILE_GLOB > helper.env
      echo HTML_FILE_GLOB=$HTML_FILE_GLOB >> helper.env
      echo MULTIPLE_TASKS=$MULTIPLE_TASKS >> helper.env
      FAILED_TASKS=0
      for TASK_ID in $TASK_IDS; do
        if [ $MULTIPLE_TASKS -eq 1 ]; then
          OUTFILE_NAME={{ test_name }}.${TASK_ID:0:8}
        else
          OUTFILE_NAME={{ test_name }}
        fi
        ci-mediator get-result {{ test_name }} --taskid $TASK_ID --output  # Saves "result" file
        TEST_RESULT_URL=$(jq -r '.url' result)
        TEST_RESULT=$(jq -r '.status' result)
        if [ $TEST_RESULT = "failed" ]; then
          FAILED_TASKS=$((FAILED_TASKS+1))
        fi
        TEST_MESSAGE=$(jq -r '.message' result)
        TEST_NAME=${TASK_ID:0:8}
        echo "TEST_RESULT_URL=${TEST_RESULT_URL}" > $OUTFILE_NAME.env
        echo "TEST_RESULT=${TEST_RESULT}" >> $OUTFILE_NAME.env
        echo "TEST_MESSAGE=\"${TEST_MESSAGE}\"" >> $OUTFILE_NAME.env
        echo "TEST_NAME=${TEST_NAME}" >> $OUTFILE_NAME.env
        echo "<html><body><h1>{{ test_name }} log</h1><pre>" > $OUTFILE_NAME.html
        echo "$TEST_RESULT_URL" >> $OUTFILE_NAME.html
        echo "</pre></body></html>" >> $OUTFILE_NAME.html
      done
      if [ $FAILED_TASKS -eq 1 ]; then
        echo "1 task has failed."
        exit 1
      elif [ $FAILED_TASKS -gt 1 ]; then
        echo "$FAILED_TASKS tasks have failed."
        exit 1
      fi
      ci-mediator cleanup {{ test_name }} --workitem $WORKITEM_ID
    - echo "TEST_RESULT=$TEST_RESULT" | tee jobdata.txt
    - echo "KOJI_TASK_ID=$KOJI_TASK_ID" | tee -a jobdata.txt
    - echo "NVR=$NVR" | tee -a jobdata.txt
  after_script:
    # GitLab CI web console strips empty lines, see:
    # https://gitlab.com/gitlab-org/gitlab/-/issues/217231#note_668935980
    - source helper.env
    - |
      for FILE in $ENV_FILE_GLOB; do
        source $FILE
        if [ $MULTIPLE_TASKS -eq 1 ]; then
          FULL_TEST_NAME={{ test_name }}.$TEST_NAME
        else
            FULL_TEST_NAME={{ test_name }}
        fi
        echo -e "\e[0;103m \e[0m"
        echo -e "\e[0;103m ==== Test results ====\e[0m"
        echo -e "\e[0;103m \e[0m"
        echo -e "\e[0;103m \e[0m Summary:"
        echo -e "\e[0;103m \e[0m The result of the $FULL_TEST_NAME test is $TEST_RESULT."
        echo -e "\e[0;103m \e[0m $TEST_MESSAGE"
        echo -e "\e[0;103m \e[0m"
        echo -e "\e[0;103m \e[0m Test logs: $TEST_RESULT_URL"
        echo -e "\e[0;103m \e[0m"
        echo -e "\e[0;103m \e[0m > Check the Test logs to find out more information."
        echo -e "\e[0;103m \e[0m > In case of issues with this test, contact the test owners mentioned in the Test logs."
        echo -e "\e[0;103m \e[0m > To restart the test, re-run this job."
        echo -e "\e[0;103m \e[0m > To waive this test result (in case of false-positive), simply add a comment describing why the failure was ignored and merge the MR."
        echo -e "\e[0;103m \e[0m"
        echo -e "\e[0;103m  ==== Test results end ====\e[0m"
        echo -e "\e[0;103m \e[0m"
      done
      tar -czf {{ test_name }}_test_results.tar.gz $HTML_FILE_GLOB
